stages:
  - build
  - test
  - deploy

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: $CI_COMMIT_BRANCH == "qa"
    - if: $CI_COMMIT_BRANCH == "production"

build-job:
  script:
    - echo "Compiling the code..."
    - echo "Compile complete."

unit-test-job:
  stage: test
  script:
    - echo "Running unit tests."

lint-test-job:
  stage: test
  script:
    - echo "Linting code."

deploy-dev:
  stage: deploy
  environment:
    name: review/$CI_COMMIT_REF_NAME
    deployment_tier: development
    url: http://$CI_COMMIT_REF_SLUG.example.org
    on_stop: stop-review
  script:
    - echo "Deploying application to dev environment"
    - echo "Application successfully deployed."
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"

stop-review:
  stage: deploy
  script:
    - echo "Stopping review"
  variables:
    GIT_STRATEGY: none
  when: manual
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"

deploy-qa:
  stage: deploy
  environment:
    name: QA
    deployment_tier: testing
    url: http://qa.example.org
  script:
    - echo "Deploying application to QA environment"
    - echo "Application successfully deployed."
  rules:
    - if: $CI_COMMIT_BRANCH == "qa"

deploy-prod:
  stage: deploy
  environment:
    name: production
    deployment_tier: production
    url: http://prod.example.org
  script:
    - echo "Deploying application to prod environment"
    - echo "Application successfully deployed."
  rules:
    - if: $CI_COMMIT_BRANCH == "production"
